import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "FalstarPlugins.Pips";

PipsWindow = class(Turbine.UI.Window);

function PipsWindow:Constructor()

   Turbine.UI.Window.Constructor(self);

   self.width = 30;
   self.height = 20;
   self.buffer = 5;

   local displayWidth, displayHeight = Turbine.UI.Display.GetSize();
   local left, top;

   self.windowWidth = 5*self.width + 4*self.buffer;
   self.windowHeight = self.height;
   left = (displayWidth - self.windowWidth)  * 0.5;
   top = (displayHeight - self.windowHeight) * 0.625;

   self:SetVisible(true);
   self:SetBackColor(Turbine.UI.Color(0.01, 1, 1, 1));
   self:SetSize(self.windowWidth, self.windowHeight);
   self:SetMouseVisible(false);
   self:SetBlendMode(Turbine.UI.BlendMode.Alpha);
   self:SetWantsUpdates(true);
   --	self:SetZOrder(100);
   
   self:SetPosition(left, top);
   
   self.player = Turbine.Gameplay.LocalPlayer.GetInstance();
   self.class = self.player:GetClass();
   self.classAtributes = nil; self.fervor = 0;
   if (self.class ==  Turbine.Gameplay.Class.Champion) then
      self.classAttributes = self.player:GetClassAttributes();
   end

   self.color = Turbine.UI.Color(0.5, 1, 0, 0);

   self.pipBar1 = Turbine.UI.Control();
   self.pipBar1:SetBackColor(self.color);
   self.pipBar1:SetParent(self);
   self.pipBar1:SetSize(self.width, self.height);
   self.pipBar1:SetPosition(0*self.width, 0);
   self.pipBar1:SetMouseVisible(false);
   self.pipBar1:SetVisible(true);

   self.pipBar2 = Turbine.UI.Control();
   self.pipBar2:SetBackColor(self.color);
   self.pipBar2:SetParent(self);
   self.pipBar2:SetSize(self.width, self.height);
   self.pipBar2:SetPosition(1*(self.width+self.buffer), 0);
   self.pipBar2:SetMouseVisible(false);
   self.pipBar2:SetVisible(true);

   self.pipBar3 = Turbine.UI.Control();
   self.pipBar3:SetBackColor(self.color);
   self.pipBar3:SetParent(self);
   self.pipBar3:SetSize(self.width, self.height);
   self.pipBar3:SetPosition(2*(self.width+self.buffer), 0);
   self.pipBar3:SetMouseVisible(false);
   self.pipBar3:SetVisible(true);

   self.pipBar4 = Turbine.UI.Control();
   self.pipBar4:SetBackColor(self.color);
   self.pipBar4:SetParent(self);
   self.pipBar4:SetSize(self.width, self.height);
   self.pipBar4:SetPosition(3*(self.width+self.buffer), 0);
   self.pipBar4:SetMouseVisible(false);
   self.pipBar4:SetVisible(true);

   self.pipBar5 = Turbine.UI.Control();
   self.pipBar5:SetBackColor(self.color);
   self.pipBar5:SetParent(self);
   self.pipBar5:SetSize(self.width, self.height);
   self.pipBar5:SetPosition(4*(self.width+self.buffer), 0);
   self.pipBar5:SetMouseVisible(false);
   self.pipBar5:SetVisible(true);

   -- self.pipLabel = Turbine.UI.Label();
   -- self.pipLabel:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
   -- self.pipLabel:SetBackColor(Turbine.UI.Color(1, 0, 0, 0));
   -- self.pipLabel:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));
   -- self.pipLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
   -- self.pipLabel:SetForeColor(Turbine.UI.Color(245/255, 222/255, 147/255));
   -- self.pipLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
   -- self.pipLabel:SetParent(self);
   -- self.pipLabel:SetSize(self.width, self.height);
   -- self.pipLabel:SetPosition(5*self.width, 0);
   -- self.pipLabel:SetMouseVisible(false);
   -- self.pipLabel:SetVisible(true);

   self:Update();
   
   --myCallback = function(sender, args)
   --   self:Update();
   --end

   --AddCallback(self.effects, "EffectAdded", myCallback);
   --AddCallback(self.effects, "EffectRemoved", myCallback);
   
end


function PipsWindow:Update()

   if (self.classAttributes == nil) then
      return;
   end

   self.fervor = self.classAttributes:GetFervor();
   -- self.pipLabel:SetText(self.fervor);

   if (self.fervor == 0) then

      self.pipBar1:SetVisible(false);
      self.pipBar2:SetVisible(false);
      self.pipBar3:SetVisible(false);
      self.pipBar4:SetVisible(false);
      self.pipBar5:SetVisible(false);

   elseif (self.fervor == 1) then

      self.pipBar1:SetVisible(true);
      self.pipBar2:SetVisible(false);
      self.pipBar3:SetVisible(false);
      self.pipBar4:SetVisible(false);
      self.pipBar5:SetVisible(false);

   elseif (self.fervor == 2) then

      self.pipBar1:SetVisible(true);
      self.pipBar2:SetVisible(true);
      self.pipBar3:SetVisible(false);
      self.pipBar4:SetVisible(false);
      self.pipBar5:SetVisible(false);

   elseif (self.fervor == 3) then

      self.pipBar1:SetVisible(true);
      self.pipBar2:SetVisible(true);
      self.pipBar3:SetVisible(true);
      self.pipBar4:SetVisible(false);
      self.pipBar5:SetVisible(false);

   elseif (self.fervor == 4) then

      self.pipBar1:SetVisible(true);
      self.pipBar2:SetVisible(true);
      self.pipBar3:SetVisible(true);
      self.pipBar4:SetVisible(true);
      self.pipBar5:SetVisible(false);

   elseif (self.fervor == 5) then

      self.pipBar1:SetVisible(true);
      self.pipBar2:SetVisible(true);
      self.pipBar3:SetVisible(true);
      self.pipBar4:SetVisible(true);
      self.pipBar5:SetVisible(true);

   end

end
